#include "StdAfx.h"
#include "SettingDlg.h"
#include "resource.h"
#include "Windowsx.h"

wstring g_size = L"";
wstring g_pid = L"";
wstring g_check = L"0";

CSettingDlg::CSettingDlg(void)
{
}


CSettingDlg::~CSettingDlg(void)
{
}

DWORD CSettingDlg::CreateSettingDialog(HINSTANCE hInstance, HWND parentWnd)
{
	DWORD ret = 0;

	g_size = this->size;
	g_pid = this->pid;
	g_check = this->check;
	ret = (DWORD)DialogBox(hInstance,MAKEINTRESOURCE(IDD_DIALOG_SET), parentWnd, (DLGPROC)DlgProc );
	if( ret == IDOK ){
		this->size = g_size;
		this->pid = g_pid;
		this->check = g_check;
	}

	return ret;
}

LRESULT CALLBACK CSettingDlg::DlgProc(HWND hDlgWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	switch (msg) {
		case WM_KEYDOWN:
			if(wp == VK_RETURN){
				{
					WCHAR buff[1024] = L"";
					GetDlgItemText(hDlgWnd,IDC_EDIT_SIZE, buff, 1024);
					g_size = buff;
					GetDlgItemText(hDlgWnd,IDC_EDIT_PID, buff, 1024);
					g_pid = buff;
					
					g_check = L"0";
					if (Button_GetCheck(GetDlgItem(hDlgWnd, IDC_CHECK_EXCLUSIVE))==BST_CHECKED) {
						g_check = L"1";
					}
				}
				EndDialog(hDlgWnd, IDOK);
			}
			break;
		case WM_INITDIALOG:
			SetDlgItemText(hDlgWnd, IDC_EDIT_SIZE, g_size.c_str());
			SetDlgItemText(hDlgWnd, IDC_EDIT_PID, g_pid.c_str());
			if (g_check==L"1") {
				Button_SetCheck(GetDlgItem(hDlgWnd,IDC_CHECK_EXCLUSIVE),BST_CHECKED);
			} else {
				Button_SetCheck(GetDlgItem(hDlgWnd,IDC_CHECK_EXCLUSIVE),BST_UNCHECKED);
			}
			return FALSE;
		case WM_COMMAND:
			switch (LOWORD(wp)) {
				case IDOK:
					{
						WCHAR buff[1024] = L"";
						GetDlgItemText(hDlgWnd,IDC_EDIT_SIZE, buff, 1024);
						g_size = buff;
						GetDlgItemText(hDlgWnd,IDC_EDIT_PID, buff, 1024);
						g_pid = buff;
						g_check = L"0";
						if (Button_GetCheck(GetDlgItem(hDlgWnd, IDC_CHECK_EXCLUSIVE))==BST_CHECKED) {
							g_check = L"1";
						}
					}
					EndDialog(hDlgWnd, IDOK);
					break;
				case IDCANCEL:
					EndDialog(hDlgWnd, IDCANCEL);
					break;
				default:
					return FALSE;
				}
		default:
			return FALSE;
	}
	return TRUE;
}

